bc: fix for() to not leave data on stack
[oweals/busybox.git] / testsuite / runtest
index 34f0de2b3f96d7e251c03af28f53c54a6686f29a..44f9cd1a1f15ccbd28c9db24ef1ebc68a7807393 100755 (executable)
@@ -1,20 +1,23 @@
 #!/bin/sh
-
 # Usage:
 # runtest [applet1] [applet2...]
 
+. ./testing.sh
+
+total_failed=0
+
 # Run one old-style test.
 # Tests are stored in applet/testcase shell scripts.
 # They are run using "sh -x -e applet/testcase".
 # Option -e will make testcase stop on the first failed command.
 run_applet_testcase()
 {
-       local applet="$1"
-       local testcase="$2"
+       applet="$1"
+       testcase="$2"
 
-       local status
-       local uc_applet=$(echo "$applet" | tr a-z A-Z)
-       local testname="$testcase"
+       status=0
+       uc_applet=$(echo "$applet" | tr a-z A-Z)
+       testname="$testcase"
 
        testname="${testname##*/}" # take basename
        if grep "^# CONFIG_$uc_applet is not set$" "$bindir/.config" >/dev/null; then
@@ -25,10 +28,12 @@ run_applet_testcase()
        if grep "^# FEATURE: " "$testcase" >/dev/null; then
                local feature=$(sed -ne 's/^# FEATURE: //p' "$testcase")
 
-               if grep "^# $feature is not set$" "$bindir/.config" >/dev/null; then
-                       echo "UNTESTED: $testname"
-                       return 0
-               fi
+               for f in $feature; do
+                       if grep "^# $f is not set$" "$bindir/.config" >/dev/null; then
+                               echo "UNTESTED: $testname"
+                               return 0
+                       fi
+               done
        fi
 
        rm -rf ".tmpdir.$applet"
@@ -36,8 +41,8 @@ run_applet_testcase()
        cd ".tmpdir.$applet" || return 1
 
 #      echo "Running testcase $testcase"
-       d="$tsdir" sh -x -e "$testcase" >"$testname.stdout.txt" 2>&1
-       status=$?
+       d="$tsdir" \
+               sh -x -e "$testcase" >"$testname.stdout.txt" 2>&1 || status=$?
        if [ $status -ne 0 ]; then
                echo "FAIL: $testname"
                if [ x"$VERBOSE" != x ]; then
@@ -54,7 +59,7 @@ run_applet_testcase()
 }
 
 # Run all old-style tests for given applet
-run_applet_tests()
+run_oldstyle_applet_tests()
 {
        local applet="$1"
        local status=0
@@ -62,19 +67,17 @@ run_applet_tests()
        for testcase in "$tsdir/$applet"/*; do
                # switch on basename of $testcase
                case "${testcase##*/}" in
-                       \#*)
-                               continue
-                               ;;
-                       *\~)
-                               continue
-                               ;;
+                       .*)     continue ;;    # .svn, .git etc
+                       *~)     continue ;;    # backup files
+                       "CVS")  continue ;;
+                       \#*)    continue ;;    # CVS merge residues
+                       *.mine) continue ;;    # svn-produced junk
+                       *.r[0-9]*) continue ;; # svn-produced junk
                esac
-               if [ "$testcase" = "$tsdir/$applet/CVS" ] ||
-                  [ "$testcase" = "$tsdir/$applet/.svn" ]; then
-                       continue
-               fi
-               run_applet_testcase "$applet" "$testcase"
-               test $? -eq 0 || status=1
+               run_applet_testcase "$applet" "$testcase" || {
+                       status=1
+                       total_failed=$((total_failed + 1))
+               }
        done
        return $status
 }
@@ -82,9 +85,10 @@ run_applet_tests()
 
 
 lcwd=$(pwd)
-[ x"$tsdir" = x ] || tsdir="$lcwd"
-[ x"$bindir" = x ] || bindir="${lcwd%/*}" # one directory up from $lcwd
+[ x"$tsdir" != x"" ] || tsdir="$lcwd"
+[ x"$bindir" != x"" ] || bindir="${lcwd%/*}" # one directory up from $lcwd
 PATH="$bindir:$PATH"
+export bindir   # some tests need to look at $bindir/.config
 
 if [ x"$VERBOSE" = x ]; then
        export VERBOSE=
@@ -96,6 +100,7 @@ if [ x"$1" = x"-v" ]; then
 fi
 
 implemented=$(
+       printf "busybox " # always implemented
        "$bindir/busybox" 2>&1 |
        while read line; do
                if [ x"$line" = x"Currently defined functions:" ]; then
@@ -113,46 +118,54 @@ fi
 # Populate a directory with links to all busybox applets
 
 LINKSDIR="$bindir/runtest-tempdir-links"
+
+# Comment this line out if you have put a different binary in $LINKSDIR
+# (say, a "standard" tool's binary) in order to run tests against it:
 rm -rf "$LINKSDIR" 2>/dev/null
-mkdir "$LINKSDIR"
+
+mkdir "$LINKSDIR" 2>/dev/null
 for i in $implemented; do
-       ln -s "$bindir/busybox" "$LINKSDIR/$i"
+       # Note: if $LINKSDIR/applet exists, we do not overwrite it.
+       # Useful if one wants to run tests against a standard utility,
+       # not an applet.
+       ln -s "$bindir/busybox" "$LINKSDIR/$i" 2>/dev/null
 done
 
 # Set up option flags so tests can be selective.
-export OPTIONFLAGS=:$(sed -nr 's/^CONFIG_//p' "$bindir/.config" | sed 's/=.*//' | xargs | sed 's/ /:/g')
+export OPTIONFLAGS=:$(
+       sed -nr 's/^CONFIG_//p' "$bindir/.config" |
+       sed 's/=.*//' | xargs | sed 's/ /:/g'
+       ):
 
 status=0
 for applet in $applets; do
-       if [ "$applet" = "links" ]; then
-               continue
-       fi
-
        # Any old-style tests for this applet?
-       if [ "$applet" != "CVS" -a -d "$tsdir/$applet" ]; then
-               run_applet_tests "$applet"
-               test $? -eq 0 || status=1
+       if [ -d "$tsdir/$applet" ]; then
+               run_oldstyle_applet_tests "$applet" || status=1
        fi
 
        # Is this a new-style test?
        if [ -f "$applet.tests" ]; then
-               if [ ! -h "$LINKSDIR/$applet" ]; then
+               if [ ! -e "$LINKSDIR/$applet" ]; then
                        # (avoiding bash'ism "${applet:0:4}")
                        if ! echo "$applet" | grep "^all_" >/dev/null; then
                                echo "SKIPPED: $applet (not built)"
                                continue
                        fi
                fi
-#              echo "Running test ${tsdir:-.}/$applet.tests"
-               PATH="$LINKSDIR:$tsdir:$bindir:$PATH" "${tsdir:-.}/$applet.tests"
-               test $? -eq 0 || status=1
+#              echo "Running test $tsdir/$applet.tests"
+               PATH="$LINKSDIR:$tsdir:$bindir:$PATH" \
+                       "$tsdir/$applet.tests"
+               rc=$?
+               total_failed=$((total_failed + rc))
+               test $rc -ne 0 && status=1
        fi
 done
 
 # Leaving the dir makes it somewhat easier to run failed test by hand
 #rm -rf "$LINKSDIR"
 
-if [ $status -ne 0 -a x"$VERBOSE" = x ]; then
-       echo "Failures detected, running with -v (verbose) will give more info"
+if [ $status -ne 0 ] && [ x"$VERBOSE" = x ]; then
+       echo "$total_failed failure(s) detected; running with -v (verbose) will give more info"
 fi
 exit $status